Title: Upgrading and Patching - OpenStack
Status: In Progress

# Upgrading and Patching - OpenStack

## Introduction

**TODO**

## Scope

**TODO**

## Upgrading

The upgrade of an OpenStack cluster in one big step is an approach requiring additional
hardware to setup an update cloud beside the productive one and leads to a longer
outage while your cloud is in read-only mode, the state is transferred to the new
one and the environments are switched. So the preferred way of upgrading an OpenStack
cloud is the rolling upgrade of each component of the system piece by piece.

Here you can choose between in-place and side-by-side upgrades. But the first one needs
to shutdown the regarding component while you're performing its upgrade. Additionally you
may have troubles in case of a rollback. So to avoid this the side by side upgrade is
the preferred way here.

Before starting the upgrade itself you should

- Perform some "cleaning" of the environment process to ensure a consistent state; for 
  example, instances not fully purged from the system after deletion may cause 
  indeterminate behavior
- Read the release notes and documentation
- Find incompatibilities between your versions

The upgrade tasks here follow the same procedure for each component:

1. Configure the new worker
1. Turn off the current worker; during this time hide the downtime using a message
   queue or a load balancer
1. Take a backup as described earlier of the old worker for a rollback
1. Copy the state of the current to the new worker
1. Start up the new worker

Now repeat these steps for each worker in an approprate order. In case of a problem it
should be easy to rollback as long as the former worker stays untouched. This is,
beside the shorter downtime, the most important advantage of the side-by-side upgrade.

The following order for service upgrades seems the most successful:

1. Upgrade the OpenStack Identity Service (Keystone).
1. Upgrade the OpenStack Image Service (Glance).
1. Upgrade OpenStack Compute (Nova), including networking components.
1. Upgrade OpenStack Block Storage (Cinder).
1. Upgrade the OpenStack dashboard.

These steps look very easy, but still are a complex procedure depending on your cloud
configuration. So we recommend to have a testing environment with a near-identical
architecture to your production system. This doesn't mean that you should use the same
sizes and hardware, which would be best but expensive. But there are some ways to reduce
the cost.

- Use your own cloud. The simplest place to start testing the next version of OpenStack 
  is by setting up a new environment inside your own cloud. This may seem odd—especially 
  the double virtualisation used in running compute nodes—but it's a sure way to very 
  quickly test your configuration.
- Use a public cloud. Especially because your own cloud is unlikely to have sufficient 
  space to scale test to the level of the entire cloud, consider using a public cloud 
  to test the scalability limits of your cloud controller configuration. Most public 
  clouds bill by the hour, which means it can be inexpensive to perform even a test 
  with many nodes.
- Make another storage endpoint on the same system. If you use an external storage plug-in 
  or shared file system with your cloud, in many cases it's possible to test that it 
  works by creating a second share or endpoint. This will enable you to test the system 
  before entrusting the new version onto your storage.
- Watch the network. Even at smaller-scale testing, it should be possible to determine 
  whether something is going horribly wrong in intercomponent communication if you 
  look at the network packets and see too many.

**TODO** Add more concrete description here.

## Patching

**TODO**
